﻿using System.Diagnostics;

namespace ReadingPerformanceCounterDemo
{
    public class PerformanceCounterReader
    {
        public delegate void PerformanceValueHandler(float nextValue);

        public event PerformanceValueHandler PerformanceValueNextValue;
    
        public void SetupCounter( string categoryName, string counterName, string instanceName )
        {
            if (!PerformanceCounterCategory.Exists(categoryName)) { return; }
            if (!PerformanceCounterCategory.CounterExists(counterName, categoryName)) { return; }

            var performanceCounter = new PerformanceCounter(categoryName, counterName, instanceName);

            while( true )
            {
                RaiseNextValue( performanceCounter.NextValue() );
                System.Threading.Thread.Sleep(500);
            }
        }

        private void RaiseNextValue( float value )
        {
            if( PerformanceValueNextValue != null )
            {
                PerformanceValueNextValue(value);
            }
        }
    }
}
